#include "simulation.h"
#include <fstream>
#include <stdarg.h>

#ifndef WIN32
#define _vsnprintf_s vsnprintf
#endif
// note: on my quick linux test, even vsnprintf wasn't present in stdarg.h .. 
// however tutorials on internet say it should be there

using namespace std;
using namespace elevasim;

namespace {

	const char* STRUCT_ENDING = "end";
	int TICKS_PER_SECOND = 2;
	double TICK_INTERVAL = 0.5;

	void Dbg_Print(char* format, ...)
	{
	#ifdef _DEBUG
		va_list argptr;
		static char string[2048];

		va_start (argptr, format);
		_vsnprintf_s(string, sizeof(string), format, argptr);
		cout << string;
		va_end (argptr);
	#endif
	}

	int main (int argc, char** argv)
	{
		istream* i;
		ifstream infile;
		srand(1);

		if (argc > 1) // filename given as the command-line option
		{
			infile.open(argv[1]);
			i = &infile;
		} else { // read from std input
			i = &cin;
		}

		/* initialize the building from the input stream
		   if the stream contains the "start" command, also launches the simulation! */
		// Building b(*i);

	#ifdef _DEBUG
		cin.get();
		1;
	#endif
		return 0;
	}

};
